commit c58cf949706491e185303796a0193e74188ae035
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Fri Jan 23 18:25:03 2026 +0000

    Fix header collapse in auto-generated bounce message.  Bug 3192

diff --git a/src/src/deliver.c b/src/src/deliver.c
index 44e163fa4..af10ff8f9 100644
--- a/src/src/deliver.c
+++ b/src/src/deliver.c
@@ -6110,7 +6110,7 @@ wording. */
     else
       fprintf(fp,
 	"The following text was generated during the delivery "
-	"attempt%s:\n", (filecount > 1)? "s" : "");
+	"attempt%s:\n", filecount > 1 ? "s" : "");
 
     for (address_item * addr = msgchain; addr; addr = nextaddr)
       {
diff --git a/src/src/routers/manualroute.c b/src/src/routers/manualroute.c
index 589db7ead..3ddde3e56 100644
--- a/src/src/routers/manualroute.c
+++ b/src/src/routers/manualroute.c
@@ -263,7 +263,7 @@ if (ob->route_list)
     {
     int rc;
 
-    DEBUG(D_route) debug_printf("route_item = %s\n", route_item);
+    DEBUG(D_route) debug_printf_indent("route_item = %s\n", route_item);
     if (!parse_route_item(route_item, &domain, &hostlist, &options))
       continue;     /* Ignore blank items */
 
@@ -276,10 +276,7 @@ if (ob->route_list)
     /* If there was a problem doing the check, defer */
 
     if (rc == DEFER)
-      {
-      addr->message = US"lookup defer in route_list";
-      return DEFER;
-      }
+      { addr->message = US"lookup defer in route_list"; return DEFER; }
     }
 
   if (!route_item) return DECLINE;  /* No pattern in the list matched */
diff --git a/src/src/transport.c b/src/src/transport.c
index 5d3b8a732..457245cd0 100644
--- a/src/src/transport.c
+++ b/src/src/transport.c
@@ -834,8 +834,13 @@ for (header_line * h = header_list; h; h = h->next) if (h->type != htype_old)
 		  tblock->rewrite_existflags, FALSE)))
 	{
 	len = hh->slen;
-	if (tctx->options & topt_truncate_headers && len > 998) len = 998;
-	if (!sendfn(tctx, hh->text, len)) return FALSE;
+	if (tctx->options & topt_truncate_headers && len > 998)
+	  {
+	  if (  !sendfn(tctx, hh->text, 991)
+	     || !sendfn(tctx, US"<trunc>\n", 8)) return FALSE;
+	  }
+	else
+	  if (!sendfn(tctx, hh->text, len)) return FALSE;
 	store_reset(reset_point);
 	continue;     /* With the next header line */
 	}
@@ -844,8 +849,13 @@ for (header_line * h = header_list; h; h = h->next) if (h->type != htype_old)
     /* Either no rewriting rules, or it didn't get rewritten */
 
     len = h->slen;
-    if (tctx->options & topt_truncate_headers && len > 998) len = 998;
-    if (!sendfn(tctx, h->text, len)) return FALSE;
+    if (tctx->options & topt_truncate_headers && len > 998)
+      {
+      if (  !sendfn(tctx, h->text, 991)
+	 || !sendfn(tctx, US"<trunc>\n", 8)) return FALSE;
+      }
+    else
+      if (!sendfn(tctx, h->text, len)) return FALSE;
     }
 
   /* Header removed */

